<?php
namespace Teknisa\COZ\Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;

class Coz01200CustoPlanejado extends \Zeedhi\Framework\Controller\Report {

	protected $crudService;
	protected $util;
	protected $dataSourceManager;
	protected $novoCodigo;
	protected $entityManager;
	protected $birtStrategy;
	protected $Coz01000ConsumoPlanejado;

	public function __construct(ReportService $reportService, $crudService, $util, $novoCodigo, $entityManager, $birtStrategy, $Coz01000ConsumoPlanejado) {
		$this->crudService    	= $crudService;
		$this->util             = $util;
		$this->novoCodigo    	= $novoCodigo;
		$this->entityManager    = $entityManager;
		$this->birtStrategy     = $birtStrategy;
		$this->Coz01000ConsumoPlanejado = $Coz01000ConsumoPlanejado;
		
		parent::__construct($reportService);
    }
	
	protected $reportMapping = array (
      'cus01200' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'DTINICIAL'       => 'P_DTINI',
                'DTFINAL'         => 'P_DTFIN',
                'CDCENTRAL'       => 'P_CDCENTRAL',
                'NRLISTA'         => 'P_NRLISTA',
                'CDTIPOCUSTOPLA'  => 'P_NRTIPOCUSTOPLAN',
                'NRCONSPLAN'      => 'P_NRCONSPLAN',
                'ORDENA'          => 'P_ORDENA',
                'CDPICTPROD'      => 'P_CDPICTPROD',
                'CDARVPRODINI'    => 'P_CDARVPRODINI',
                'CDARVPRODFIN'    => 'P_CDARVPRODFIN',
                'NRORG'           => 'P_NRORG'
            )
        ),
        'cus01203' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'DTINICIAL'       => 'P_DTINI',
                'DTFINAL'         => 'P_DTFIN',
                'CDCENTRAL'       => 'P_CDCENTRAL',
                'NRLISTA'         => 'P_NRLISTA',
                'CDTIPOCUSTOPLA'  => 'P_NRTIPOCUSTOPLAN',
                'NRCONSPLAN'      => 'P_NRCONSPLAN',
                'ORDENA'          => 'P_ORDENA',
                'CDPICTPROD'      => 'P_CDPICTPROD',
                'CDARVPRODINI'    => 'P_CDARVPRODINI',
                'CDARVPRODFIN'    => 'P_CDARVPRODFIN',
                'NRORG'           => 'P_NRORG'
            )
        ),
        'cus01201' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'DTINICIAL'       => 'P_DTINI',
                'DTFINAL'         => 'P_DTFIN',
                'CDCENTRAL'       => 'P_CDCENTRAL',
                'NRLISTA'         => 'P_NRLISTA',
                'CDTIPOCUSTOPLA'  => 'P_NRTIPOCUSTOPLAN',
                'NRCONSPLAN'      => 'P_NRCONSPLAN',
                'ORDENA'          => 'P_ORDENA',
                'CDPICTPROD'      => 'P_CDPICTPROD',
                'CDARVPRODINI'    => 'P_CDARVPRODINI',
                'CDARVPRODFIN'    => 'P_CDARVPRODFIN',
                'NRORG'           => 'P_NRORG'
            )
        ),
        'cus01204' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'DTINICIAL'       => 'P_DTINI',
                'DTFINAL'         => 'P_DTFIN',
                'CDCENTRAL'       => 'P_CDCENTRAL',
                'NRLISTA'         => 'P_NRLISTA',
                'CDTIPOCUSTOPLA'  => 'P_NRTIPOCUSTOPLAN',
                'NRCONSPLAN'      => 'P_NRCONSPLAN',
                'ORDENA'          => 'P_ORDENA',
                'CDPICTPROD'      => 'P_CDPICTPROD',
                'CDARVPRODINI'    => 'P_CDARVPRODINI',
                'CDARVPRODFIN'    => 'P_CDARVPRODFIN',
                'NRORG'           => 'P_NRORG'
            )
        ),
        'cus01202' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'DTINICIAL'       => 'P_DTINI',
                'DTFINAL'         => 'P_DTFIN',
                'CDCENTRAL'       => 'P_CDCENTRAL',
                'NMCENTRAL'       => 'P_NMCENTRAL',
                'NRLISTA'         => 'P_NRLISTA',
                'CDTIPOCUSTOPLA'  => 'P_NRTIPOCUSTOPLAN',
                'NRCONSPLAN'      => 'P_NRCONSPLAN',
                'ORDENA'          => 'P_ORDENA',
                'CDPICTPROD'      => 'P_CDPICTPROD',
                'CDARVPRODINI'    => 'P_CDARVPRODINI',
                'CDARVPRODFIN'    => 'P_CDARVPRODFIN',
                'NRORG'           => 'P_NRORG'
            )
        )
    );
	
	public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response){
	    try{
	        
	        $row = $request->getRow();

    	    if(empty($row['NMSERVFILI'])) $row['NMSERVFILI'] = $this->Coz01000ConsumoPlanejado->filtraServicos($row);
	    	
    	    $row['NRLISTA'] = $this->Coz01000ConsumoPlanejado->gerarListaServ($row['NMSERVFILI'], $row['NRORG']);
    
    	    $nrListaConsplan = $this->Coz01000ConsumoPlanejado->gerarLista($row['NMSERVFILI'], $row['NRORG']);

    	    $cdprodini = empty($row['CDARVPRODINI']) ? '0' : $row['CDARVPRODINI'];
            if(empty($row['CDARVPRODFIN'])) $cdprodfin = 'Z';
            else $cdprodfin = str_pad($row['CDARVPRODFIN'], 10, "Z", STR_PAD_RIGHT);
            
            $row['CDARVPRODINI'] = $cdprodini;
            $row['CDARVPRODFIN'] = $cdprodfin;
            
    	    $row['NRCONSPLAN'] = $this->Coz01000ConsumoPlanejado->gerarNrConsplan($nrListaConsplan, $row);
    	    $this->birtStrategy->setReportFormat(strtolower($row['QR2TYPE']));
	    }catch(\Exception $e){
	        $response->setError(new Error($e->getMessage(), 500));
	    }
	}
	
	public function relCustomizavelCustoConsumo(DTO\Request\Row $request, DTO\Response $response) {
	    $row = $request->getRow();
	    
    	if(empty($row['NMSERVFILI'])) $row['NMSERVFILI'] = $this->Coz01000ConsumoPlanejado->filtraServicos($row);
	    	
	    $row['NRLISTA'] = $this->Coz01000ConsumoPlanejado->gerarListaServ($row['NMSERVFILI'], $row['NRORG']);
	    $nrListaConsplan = $this->Coz01000ConsumoPlanejado->gerarLista($row['NMSERVFILI'], $row['NRORG']);
	    $row['NRCONSPLAN'] = $this->Coz01000ConsumoPlanejado->gerarNrConsplan($nrListaConsplan, $row);

	    $cdprodini = empty($row['CDARVPRODINI']) ? '0' : $row['CDARVPRODINI'];
        if(empty($row['CDARVPRODFIN'])) $cdprodfin = 'Z';
        else $cdprodfin = str_pad($row['CDARVPRODFIN'], 10, "Z", STR_PAD_RIGHT);
        
        $row['CDARVPRODINI'] = $cdprodini;
        $row['CDARVPRODFIN'] = $cdprodfin;
    	
	    $sql = "SELECT
                    CENTRAL.CDFILIAL AS CDCENTRAL,
                    CENTRAL.NMFILIAL AS NMCENTRAL,
                    :P_DTINI AS DTINICIAL,
                    :P_DTFIN AS DTFINAL,
                    TCP.CDTIPOCUSTO AS CDTPCUSPLAN,
                    TCP.NMTIPOCUSTO AS CUSTOPLANEJADO,
                    TO_CHAR(C.DT,'DD/MM/YYYY') AS DATA,
                    TO_CHAR(C.DT,'Day') AS DIASEMANA,
                    FA.CDFILIAL AS CODAGREGADA,
                    FA.NMFILIAL AS AGREGADA,
                    ( FA.CDFILIAL || ' - ' || FA.NMFILIAL ) AS FILIAL,
                    P.CDARVPROD AS CODPRODUTO,
                    P.NMPRODUTO AS PRODUTO,
                    P.SGUNIDADE AS UN,
                	COMENSAISDIA.QTCOMENSAIS, 
                	DECODE(
                	   NVL(COMENSAISDIA.QTCOMENSAIS, 0),
                	   0,
                	   0,
                	   SUM(C.CUSTOPLAN) / COMENSAISDIA.QTCOMENSAIS) AS PERCAPITAPLA,
                    SUM(C.CUSTOPLAN) AS CUSTO,
                    P.NRORG,
                    C.IDTPREQPROD AS TIPO,
                    S.CDGRUPSERV AS CODGRUPOSERVICO,
                    S.NMGRUPSERV AS GRUPOSERVICO
                FROM
                    TIPOCUSTO TCP, (
                	SELECT CA.DTCARDAPIO       AS DT,
                	       SUM(CA.QTCOMESTICAR) AS QTCOMENSAIS,
                	       SUM(CA.QTCLIESTICAR) AS QTCLIESTICAR,
                	       L.CDGRUPSERV
                	  FROM CARDADIA      CA,
                	       LISTA_SERVICO L
                	 WHERE CA.DTCARDAPIO BETWEEN :P_DTINI AND :P_DTFIN
                	   AND L.NRLISTA = :P_NRLISTA
                	   AND L.CDFILIAL = CA.CDFILIAL
                	   AND L.CDSERVFILI = CA.CDSERVFILI
                	 GROUP BY CA.DTCARDAPIO,
                	          L.CDGRUPSERV
                		) COMENSAISDIA,(
                        SELECT
                			MP.CDFILICPLA,
                            MP.DT,
                            MP.CDPRODPRODUCAO AS CDPRODUTO,
                            SUM(MP.CUSTOPLAN) CUSTOPLAN,
                            MP.IDTPREQPROD,
                            MP.CDGRUPSERV
                        FROM
                            (
                                SELECT
                					CONS.CDFILICPLA,
                                    CONS.DTCONSPLAN AS DT,
                                    SUM(CUSTO) * (CONS.QTCONSPLAN + DECODE(NVL(PARAM.PERCACRESCPA, 0), 0, 0, CONS.QTCONSPLAN * (PARAM.PERCACRESCPA / 100))) AS CUSTOPLAN,
                                    CONS.CDPRODPRODUCAO,
                                    CONS.IDTPREQPROD,
                                    CONS.CDGRUPSERV
                                FROM
                                    (
                                        SELECT 
                							C.CDFILICPLA,
                                            C.DTCONSPLAN,
                                            ((C.QTCONSPLAN) 
                                                + DECODE(R.IDFINALIZACAO, 'F', 0, (NVL(C.QTCOMPLPRODCPLA, 0))) 
                                                + ((C.QTCONSPLAN / C.QTCOMESTCPLA) * (DECODE(NVL(R.QTAMOSTRA,0), 0, 0, 
                                                    R.QTAMOSTRA * 100 / R.QTPADRAO)) / 100 ))  AS QTCONSPLAN,
                                            DECODE(R.IDTPREQPROD, 'P', R.CDPRODPRODUCAO, DECODE(R.IDTPREQPROD, 'I', R.CDPRODPRODUCAO, R.CDPRODUTO)) AS CDPRODPRODUCAO,
                                            R.CDPRODUTO,
                                            NVL(R.QTAMOSTRA,0) QTAMOSTRA,
                                            CUSTO_PRODUTO(DECODE(R.IDTPREQPROD, 'E', C.CDFILICPLA, :P_CDCENTRAL),R.CDPRODUTO,:P_NRTIPOCUSTOPLAN,C.DTCONSPLAN,SYSDATE) AS CUSTO,
                                            DECODE(R.IDTPREQPROD, 'I', 'P', R.IDTPREQPROD) AS IDTPREQPROD,
                                            L.CDGRUPSERV
                                        FROM
                                            CONSPLAN C
                                            INNER JOIN TABLE ( RECEITA_UTIL(C.CDFILICPLA,C.CDSERVCPLA,C.CDPRATCONSPL,C.CDFAPRATCPLA,'0','Z',NULL,0,0,'S') ) R
                                                ON R.CDPRODPRODUCAO IS NOT NULL
                                                --AND R.IDTPREQPROD <> 'E'
                								AND R.CDPRATO = C.CDPRATCONSPL AND R.CDFILAUXPRAT = C.CDFAPRATCPLA
                                            INNER JOIN LISTA_SERVICO L ON L.NRLISTA = :P_NRLISTA
                                                          AND C.CDFILICPLA = L.CDFILIAL AND C.CDSERVCPLA = L.CDSERVFILI    
                                        WHERE C.NRCONSPLAN =:P_NRCONSPLAN
                                            AND ( E_AGREGADA(:P_CDCENTRAL,C.CDFILICPLA,C.CDSERVCPLA,C.CDTPPRATCPLA,C.DTCONSPLAN) > 0 )
                                           -- AND C.IDTPREQPROD <> 'E'
                							AND R.IDTPREQPROD = C.IDTPREQPROD
                                            AND R.CDPRODUTO = C.CDPRODCPLA
                                        GROUP BY
                							C.CDFILICPLA,
                                            C.DTCONSPLAN,
                                            R.CDPRODPRODUCAO,
                                            R.CDPRODUTO,
                                            R.QTAMOSTRA,
                                            R.IDTPREQPROD,
                                            R.IDFINALIZACAO,
                                            L.CDGRUPSERV,
                                            R.QTPADRAO,
                                            C.QTCOMPLPRODCPLA, 
                                            C.QTCONSPLAN, 
                                            C.QTCOMESTCPLA
                                UNION  
                                SELECT 
                						C.CDFILICPLA,
                                            C.DTCONSPLAN,
                                            SUM(NVL(C.QTCOMPLPRODCPLA,0) ) * SUM(C.QTCOMESTCPLA) AS QTCONSPLAN,
                                            R.CDPRODUTO AS CDPRODPRODUCAO,
                                            R.CDPRODUTO,
                                            0 AS QTAMOSTRA,
                                            CUSTO_PRODUTO(:P_CDCENTRAL,R.CDPRODUTO,:P_NRTIPOCUSTOPLAN,C.DTCONSPLAN,SYSDATE) AS CUSTO,
                                            'D' AS IDTPREQPROD,
                							L.CDGRUPSERV
                                        FROM
                                            CONSPLAN C
                                            INNER JOIN TABLE ( RECEITA_UTIL(C.CDFILICPLA,C.CDSERVCPLA,C.CDPRATCONSPL,C.CDFAPRATCPLA,'0','Z',NULL,0,0,'S') ) R
                                                ON R.CDPRODPRODUCAO IS NOT NULL
                                                AND R.IDTPREQPROD <> 'E' AND R.IDFINALIZACAO = 'F'
                								AND R.CDPRATO = C.CDPRATCONSPL AND R.CDFILAUXPRAT = C.CDFAPRATCPLA
                                            INNER JOIN LISTA_SERVICO L ON L.NRLISTA = :P_NRLISTA
                                                          AND C.CDFILICPLA = L.CDFILIAL AND C.CDSERVCPLA = L.CDSERVFILI    
                                        WHERE C.NRCONSPLAN =:P_NRCONSPLAN
                                            AND ( E_AGREGADA(:P_CDCENTRAL,C.CDFILICPLA,C.CDSERVCPLA,C.CDTPPRATCPLA,C.DTCONSPLAN) > 0 )
                                            AND C.IDTPREQPROD <> 'E'
                                            AND C.QTCOMPLPRODCPLA > 0
                							AND R.IDTPREQPROD = C.IDTPREQPROD
                                            AND R.CDPRODUTO = C.CDPRODCPLA
                                        GROUP BY
                                           C.CDFILICPLA, C.DTCONSPLAN,
                                            R.CDPRODUTO,
                							L.CDGRUPSERV
                                     ) CONS
                                INNER JOIN PARAMPLANEJA PARAM ON PARAM.CDFILIAL = :P_CDCENTRAL
                                GROUP BY
                					CONS.CDFILICPLA,
                                    CONS.DTCONSPLAN, QTCONSPLAN,
                                    CONS.CDPRODPRODUCAO,
                                    CONS.IDTPREQPROD,
                                    CONS.CDGRUPSERV, 
                                    PARAM.PERCACRESCPA
                            ) MP
                        GROUP BY
                			MP.CDFILICPLA,
                            MP.DT,
                            MP.CDPRODPRODUCAO,
                            MP.IDTPREQPROD,
                            MP.CDGRUPSERV
                        UNION ALL
                		SELECT 
                			C.CDFILICPLA,
                			C.DTCONSPLAN AS DT,
                			C.CDPRODCPLA AS CDPRODUTO,
                			CUSTO_PRODUTO(:P_CDCENTRAL, C.CDPRODCPLA,:P_NRTIPOCUSTOPLAN,C.DTCONSPLAN,SYSDATE) * SUM(C.QTCONSPLAN) AS CUSTOPLAN,
                			C.IDTPREQPROD,
                			L.CDGRUPSERV
                		FROM
                			CONSPLAN C
                			INNER JOIN LISTA_SERVICO L ON L.NRLISTA = :P_NRLISTA
                								  AND C.CDFILICPLA = L.CDFILIAL AND C.CDSERVCPLA = L.CDSERVFILI
                		WHERE
                			C.NRCONSPLAN =:P_NRCONSPLAN
                			AND C.DTCONSPLAN BETWEEN :P_DTINI AND :P_DTFIN
                			AND ( E_AGREGADA(:P_CDCENTRAL,C.CDFILICPLA,C.CDSERVCPLA,C.CDTPPRATCPLA,C.DTCONSPLAN) > 0 )
                			--AND C.IDTPREQPROD = 'D'
                			AND C.IDCONSPLAN IN ('P', 'F')
                		GROUP BY
                			C.CDFILICPLA,
                			C.DTCONSPLAN,
                			C.CDPRODCPLA,
                			C.IDTPREQPROD,
                			L.CDGRUPSERV
                    ) C
                    INNER JOIN PRODUTO P ON P.CDPRODUTO = C.CDPRODUTO
                    INNER JOIN FILIAL CENTRAL ON CENTRAL.CDFILIAL = :P_CDCENTRAL
                    INNER JOIN FILIAL FA ON FA.CDFILIAL = C.CDFILICPLA
                    INNER JOIN GRUPSERV S ON S.CDGRUPSERV = C.CDGRUPSERV
                WHERE
                    P.CDARVPROD BETWEEN :P_CDARVPRODINI AND :P_CDARVPRODFIN
                    AND TCP.CDTIPOCUSTO = :P_NRTIPOCUSTOPLAN
                   AND COMENSAISDIA.DT = C.DT
                   AND COMENSAISDIA.CDGRUPSERV = C.CDGRUPSERV
                GROUP BY
                    CENTRAL.CDFILIAL, CENTRAL.NMFILIAL, TCP.CDTIPOCUSTO, TCP.NMTIPOCUSTO, C.DT, FA.CDFILIAL, FA.NMFILIAL,
                    P.CDARVPROD, P.NMPRODUTO, P.SGUNIDADE, P.NRORG, C.IDTPREQPROD, S.CDGRUPSERV, S.NMGRUPSERV, COMENSAISDIA.QTCOMENSAIS
                ORDER BY
                    C.DT,
                    DECODE(:P_ORDENA,'C',CDARVPROD,NMPRODUTO)";
                    
	    $params = array (
	        "P_DTINI"           => $row["DTINICIAL"],
	        "P_CDCENTRAL"       => $row["CDCENTRAL"],
	        "P_CDARVPRODINI"    => $row["CDARVPRODINI"],
	        "P_CDARVPRODFIN"    => $row["CDARVPRODFIN"],
	        "P_NRTIPOCUSTOPLAN" => $row["CDTIPOCUSTOPLA"],
	        "P_ORDENA"          => $row["ORDENA"],
	        "P_NRLISTA"         => $row["NRLISTA"],
	        "P_NRCONSPLAN"      => $row["NRCONSPLAN"],
	        "P_DTFIN"           => $row["DTFINAL"]
	   );

	   $data = $this->entityManager->getConnection()->fetchAll($sql, $params);
       $response->addDataset(new DataSet('relCustomizavel', array($data)));
	}
}